package edu.sjsu.rhinofaces;

import java.util.logging.Logger;

import javax.el.ELContext;
import javax.el.MethodExpression;
import javax.el.MethodInfo;

/**
 
   @author Tom Austin
 */
public class RhinoMethodExpression extends MethodExpression
{
   private static Logger logger = Logger.global;
   
   private JavaScriptEnvironment jsEnironment;
   private MethodExpression delegate;
   
   public RhinoMethodExpression(MethodExpression delegate)
   {
      this.delegate = delegate;
      this.jsEnironment = new JavaScriptEnvironment();
   }

   /**
      @see javax.el.MethodExpression#getMethodInfo(javax.el.ELContext)
    */
   @Override
   public MethodInfo getMethodInfo(ELContext context)
   {
      return delegate.getMethodInfo(context);
   }

   /**
      Calls JS method.
      @see javax.el.MethodExpression#invoke(javax.el.ELContext, java.lang.Object[])
    */
   @Override
   public Object invoke(ELContext context, Object[] params)
   {
      logger.info("**********************RMethExp:" + params);
      return null;
      //return jsEnironment.evalRhino(params);
   }

   /**
    @see javax.el.Expression#equals(java.lang.Object)
    */
   @Override
   public boolean equals(Object arg0)
   {
      return delegate.equals(arg0);
   }

   /**
    @see javax.el.Expression#getExpressionString()
    */
   @Override
   public String getExpressionString()
   {
      return delegate.getExpressionString();
   }

   /**
    @see javax.el.Expression#hashCode()
    */
   @Override
   public int hashCode()
   {
      return delegate.hashCode();
   }

   /**
    @see javax.el.Expression#isLiteralText()
    */
   @Override
   public boolean isLiteralText()
   {
      return delegate.isLiteralText();
   }

}
